<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>Exponential Search</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <h1 id="exponential-search">Exponential Search</h1>
    <h4 id="prerequisites">Prerequisites</h4>
    <ul>
      <li>
        <a
          href="https://github.com/faridevnz/Algorithms-Explanation/blob/master/en/Search%20Algorithms/Binary%20Search.md"
          >Binary Search algorithm</a
        >
      </li>
    </ul>
    <h4 id="problem-statement">Problem Statement</h4>
    <p>
      Given a sorted array of <em>n</em> elements, write a function to search
      for the index of a given element (target)
    </p>
    <h4 id="approach">Approach</h4>
    <ul>
      <li>
        Search for the <strong>range</strong> within which the target is
        included increasing <em>index</em> by powers of 2
      </li>
      <li>
        If this range exists in array apply the Binary Search algorithm over it
      </li>
      <li>Else return -1</li>
    </ul>
    <h4 id="example">Example</h4>
    <div class="sourceCode" id="cb1">
      <pre
        class="sourceCode markdown"
      ><code class="sourceCode markdown"><a class="sourceLine" id="cb1-1" title="1">arr = [1, 2, 3, 4, 5, 6, 7, ... 998, 999, 1_000]</a>
<a class="sourceLine" id="cb1-2" title="2"></a>
<a class="sourceLine" id="cb1-3" title="3">target = 998</a>
<a class="sourceLine" id="cb1-4" title="4">index = 0</a>
<a class="sourceLine" id="cb1-5" title="5">1. <span class="fl">SEARCHING FOR THE RANGE</span></a>
<a class="sourceLine" id="cb1-6" title="6"><span class="fl">index = 1, 2, 4, 8, 16, 32, 64, ..., 512, ..., 1_024</span></a>
<a class="sourceLine" id="cb1-7" title="7"><span class="fl">after 10 iteration we have the index at 1_024 and outside of the array </span></a>
<a class="sourceLine" id="cb1-8" title="8"><span class="fl">2. BINARY SEARCH</span></a>
<a class="sourceLine" id="cb1-9" title="9"><span class="fl">Now we can apply the binary search on the subarray from 512 and 1_000.</span></a></code></pre>
    </div>
    <p>
      <strong><em>Note</em></strong
      >: we apply the Binary Search from 512 to 1_000 because at
      <code>i = 2^10 = 1_024</code> the array is finisced and the target number
      is less than the latest index of the array ( 1_000 ).
    </p>
    <h4 id="time-complexity">Time Complexity</h4>
    <p>
      <strong>worst case:</strong> <code>O(log *i*)</code> where
      <code>*i* = index</code> (position) of the target
    </p>
    <p><strong>best case:</strong> <code>O(*1*)</code></p>
    <h4 id="complexity-explanation">Complexity Explanation</h4>
    <ul>
      <li>
        The complexity of the first part of the algorithm is
        <strong>O( log <em>i</em> )</strong> because if <em>i</em> is the
        position of the target in the array, after doubling the search
        <em>index</em> <code>⌈log(i)⌉</code> times, the algorithm will be at a
        search index that is greater than or equal to <em>i</em>. We can write
        <code>2^⌈log(i)⌉ &gt;= i</code>
      </li>
      <li>
        The complexity of the second part of the algorithm also is
        <strong>O ( log <em>i</em> )</strong> because that is a simple Binary
        Search. The Binary Search complexity ( as explained
        <a
          href="https://github.com/faridevnz/Algorithms-Explanation/blob/master/en/Search%20Algorithms/Binary%20Search.md"
          >here</a
        >
        ) is O( <em>n</em> ) where <em>n</em> is the length of the array. In the
        Exponential Search, the length of the array on which the algorithm is
        applied is <code>2^i - 2^(i-1)</code>, put into words it means ‘( the
        length of the array from start to <em>i</em> ) - ( the part of array
        skipped until the previous iteration )’. Is simple verify that
        <code>2^i - 2^(i-1) = 2^(i-1)</code>
      </li>
    </ul>
    <p>
      After this detailed explanation we can say that the the complexity of the
      Exponential Search is:
    </p>
    <div class="sourceCode" id="cb2">
      <pre
        class="sourceCode mathematica"
      ><code class="sourceCode mathematica"><a class="sourceLine" id="cb2-1" title="1"><span class="fu">O</span>(<span class="fu">log</span> <span class="fu">i</span>) + <span class="fu">O</span>(<span class="fu">log</span> <span class="fu">i</span>) = 2O(<span class="fu">log</span> <span class="fu">i</span>) = <span class="fu">O</span>(<span class="fu">log</span> <span class="fu">i</span>)</a></code></pre>
    </div>
    <h4 id="binary-search-vs-exponential-search">
      Binary Search vs Exponential Search
    </h4>
    <p>
      Let’s take a look at this comparison with a less theoretical example.
      Imagine we have an array with<code>1_000_000</code> elements and we want
      to search an element that is in the <code>4th</code> position. It’s easy
      to see that:
    </p>
    <ul>
      <li>
        The Binary Search start from the middle of the array and arrive to the
        4th position after many iterations
      </li>
      <li>
        The Exponential Search arrive at the 4th index after only 2 iterations
      </li>
    </ul>
    <h4 id="code-implementation-links">Code Implementation Links</h4>
    <ul>
      <li>
        <a
          href="https://github.com/TheAlgorithms/C-Plus-Plus/blob/master/search/exponential_search.cpp"
          >C++</a
        >
      </li>
      <li>
        <a
          href="https://github.com/TheAlgorithms/Javascript/blob/master/Search/ExponentialSearch.js"
          >JavaScript</a
        >
      </li>
    </ul>
  </body>
</html>
